"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.connect = exports.MyRedux = exports.Provider = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.isEqual = isEqual;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StoreContext = (0, _react.createContext)({ store: {} });

var Provider = exports.Provider = function (_Component) {
    _inherits(Provider, _Component);

    function Provider() {
        _classCallCheck(this, Provider);

        return _possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).apply(this, arguments));
    }

    _createClass(Provider, [{
        key: "render",
        value: function render() {
            return _react2.default.createElement(
                StoreContext.Provider,
                { value: this.props.store },
                _react.Children.only(this.props.children)
            );
        }
    }]);

    return Provider;
}(_react.Component);

var MyRedux = exports.MyRedux = function () {
    function MyRedux(reducer) {
        var initState = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

        _classCallCheck(this, MyRedux);

        _initialiseProps.call(this);

        this._(reducer, initState);
        this.dispatch();
        this._state = _extends({}, this._state, initState);
    }

    _createClass(MyRedux, [{
        key: "_",
        value: function _(reducer) {
            this._state = {};
            this._reducer = reducer;
            this._listener_arr = [];
            this._type_cache = {};
        }
    }, {
        key: "_setState",
        value: function _setState(reducer, action, reducer_key, no_cache) {
            var old_state = this._state[reducer_key];
            var new_state = reducer(old_state, action);
            if (!no_cache && reducer_key && action.type && old_state !== new_state) {
                this._type_cache[action.type] || (this._type_cache[action.type] = new Set());
                this._type_cache[action.type].add({ reducer: reducer, reducer_key: reducer_key });
            }
            this._state[reducer_key] = new_state;
        }
    }, {
        key: "_reducerFromCache",
        value: function _reducerFromCache(action) {
            var _this2 = this;

            var type = action.type;
            if (type && this._type_cache[type]) {
                var type_cache = this._type_cache[type];
                type_cache.forEach(function (args) {
                    var reducer = args.reducer,
                        reducer_key = args.reducer_key;

                    _this2._setState(reducer, action, reducer_key, true);
                });
                return true;
            } else {
                return false;
            }
        }
    }]);

    return MyRedux;
}();

var _initialiseProps = function _initialiseProps() {
    var _this5 = this;

    this.dispatch = function () {
        var action = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var render = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;

        if (typeof action === "function") {
            action(_this5.dispatch, _this5.getState);
            return _this5;
        }
        if (type) {
            action.type = type;
        }
        var reducers = _this5._reducer;

        if (!_this5._reducerFromCache(action)) {
            Object.keys(reducers).map(function (reducer_key) {
                var reducer = reducers[reducer_key];
                _this5._setState(reducer, action, reducer_key);
            });
        }
        if (render && _this5._listener_arr.length > 0) {
            _this5._listener_arr.reverse().map(function (v) {
                v();
            });
        }
        return _this5;
    };

    this.subscribe = function (listener) {
        if (typeof listener !== "function") {
            return false;
        }
        _this5._listener_arr.push(listener);
        return function () {
            if (_this5._listener_arr.length <= 0) {
                return;
            }
            var index = _this5._listener_arr.indexOf(listener);
            _this5._listener_arr.splice(index, 1);
        };
    };

    this.getState = function () {
        return _this5._state;
    };
};

var connect = exports.connect = function connect() {
    var mapReducer = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function () {};
    return function (component) {
        var that = void 0;

        var Wrap = function (_Component2) {
            _inherits(Wrap, _Component2);

            function Wrap(props) {
                _classCallCheck(this, Wrap);

                var _this3 = _possibleConstructorReturn(this, (Wrap.__proto__ || Object.getPrototypeOf(Wrap)).call(this));

                that = props.store;
                var reducers = _extends({}, mapReducer(that.getState()));
                _this3.state = reducers;
                return _this3;
            }

            _createClass(Wrap, [{
                key: "componentDidMount",
                value: function componentDidMount() {
                    var _this4 = this;

                    this.unsubscribe = that.subscribe(function () {
                        _this4.setState(_extends({}, mapReducer(that.getState())));
                    });
                }
            }, {
                key: "componentWillUnmount",
                value: function componentWillUnmount() {
                    this.unsubscribe();
                }
            }, {
                key: "shouldComponentUpdate",
                value: function shouldComponentUpdate(nextProps, nextState) {
                    if (isEqual(nextProps, this.props) || isEqual(nextState, this.state)) {
                        return true;
                    }
                    return false;
                }
            }, {
                key: "render",
                value: function render() {
                    return (0, _react.createElement)(component, _extends({}, this.state));
                }
            }]);

            return Wrap;
        }(_react.Component);

        var getWrap = function getWrap() {
            return _react2.default.createElement(
                StoreContext.Consumer,
                null,
                function (store) {
                    return _react2.default.createElement(Wrap, { store: store });
                }
            );
        };

        return getWrap;
    };
};

function isEqual(objA, objB) {
    if (objA === objB) {
        return true;
    }
    var keysA = Object.keys(objA);
    var keysB = Object.keys(objB);

    if (keysA.length !== keysB.length) {
        return false;
    }
    var hasOwn = Object.prototype.hasOwnProperty;
    for (var i = 0; i < keysA.length; i++) {
        if (!hasOwn.call(objB, keysA[i]) || objA[keysA[i]] !== objB[keysA[i]]) {
            return false;
        }
    }
    return true;
}